<?php
/***************************************\
|			PHP OPTIMISATEUR			|
|			   Version 1.1				|
\***************************************/

include('files/functions.php');

### Création de nouveau fichier de configuration ###
if (isset($_POST['DIRsource'])) {
	// Quelques traitements avant d'enregistrer
	$_POST['copyCOLOR'] = implode(' ', $_POST['copyCOLOR']);
	$_POST['copyPOS'] = implode('-', $_POST['copyPOS']);
	if(!isset($_POST['PluginsBefore'])) $_POST['PluginsBefore'] = null;
	if(!isset($_POST['PluginsProcess'])) $_POST['PluginsProcess'] = null;
	if(!isset($_POST['PluginsAfter'])) $_POST['PluginsAfter'] = null;
	if (!preg_match('#(.*)/$#', $_POST['DIRsource'])) $_POST['DIRsource'] .= '/';
	if (!preg_match('#(.*)/$#', $_POST['DIRsortie'])) $_POST['DIRsortie'] .= '/';
	
	// Contenu du fichier
	$content = '<?xml version="1.0" encoding="UTF-8"?>'."\r\n".'<config>'."\r\n";
	$content .= XMLcreate($_POST, 0);
	$content .= '</config>';
	file_put_contents('config.xml', $content);
	
	header('Location:index.php');
}


include('files/header.php');

// Fichier de configuration
if (!file_exists('config.xml')) {
	$Errors['ErrorFile'] = true;
}



### ERREURS ###
if (isset($Errors)) {
	$i=0;
	foreach ($Errors as $key => $null) {
		// Dégueulasse les ternaires à la suite ! mais j'aime ça
		echo '<div class="error">'.l10n($key).' '.(($i==0)?'<a href="setup.php">'.l10n('Back').'</a></div>':'</div>');
		$i++;
	}
}



### EXECUTION ###
if (!isset($Errors)) {
	// Configuration
	extract(load_config());

	$copyCOLOR = explode(' ', $copyCOLOR);
	$copyPOS = explode('-', $copyPOS);


	### Gestion des nouveaux plugins ###
	// Ajoute la configuration des plugins non-installés aux tableaux, il faut valider le formulaire pour les installer
	$Plugins = glob('plugins/*.xml');
	$NewPlugins = array();

	foreach ($Plugins as $plugin) {
		// nom du plugin
		preg_match('#plugins/(.*).xml#', $plugin, $matches);
		$plugin_name = $matches[1];
		// configuration du plugin
		$plugin = XMLparse(simplexml_load_file($plugin));
		// mode du plugin (effacage pour pas l'inscrire dans la config)
		$plugin_mode = $plugin['mode'];
		unset($plugin['mode']);
		
		if (!array_key_exists($plugin_name, ${$plugin_mode})) {
			${$plugin_mode}[$plugin_name] = $plugin;
			$NewPlugins[$plugin_name] = true;
		}
	}


	### Formulaire ###
	echo '
	<script type="text/javascript">
		function suivant(enCours, suivant, limite) {
			if (enCours.value.length == limite) {
				enCours.form.elements[suivant].select();
			}
		}
	</script>
		
	<form action="setup.php" method="post">
	<div class="config">
		<h2>'.l10n('Configuration').'</h2>
		<ul>
			<li>
				<span class="title">'.l10n('Folders').'</span>
				<table>
					<tr>
						<td><b>'.l10n('FolderIn').' :</b></td>
						<td><input type="text" name="DIRsource" value="'.$DIRsource.'"/></td>
					</tr>
					<tr>
						<td><b>'.l10n('FolderOut').' :</b></td>
						<td><input type="text" name="DIRsortie" value="'.$DIRsortie.'"/></td>
					</tr>
				</table>
			</li>
			<li>
				<span class="title">'.l10n('Options').'</span>
				<table>
					<tr>
						<td><b>'.l10n('silentORNOT').' :</b></td>
						<td><input type="radio" name="silentORNOT" value="true" '.(($silentORNOT)?'checked':'').'/> '.l10n('yes').' <input type="radio" name="silentORNOT" value="false" '.((!$silentORNOT)?'checked':'').'/> '.l10n('no').'</td>
					</tr>
					<tr>
						<td><b>'.l10n('DIRhighORNOT').' :</b></td>
						<td><input type="radio" name="DIRhighORNOT" value="true" '.(($DIRhighORNOT)?'checked':'').'/> '.l10n('yes').' <input type="radio" name="DIRhighORNOT" value="false" '.((!$DIRhighORNOT)?'checked':'').'/> '.l10n('no').'</td>
					</tr>
					<tr>
						<td><b>'.l10n('DIMhdORNOT').' :</b></td>
						<td><input type="radio" name="DIMhdORNOT" value="true" '.(($DIMhdORNOT)?'checked':'').'/> '.l10n('yes').' <input type="radio" name="DIMhdORNOT" value="false" '.((!$DIMhdORNOT)?'checked':'').'/> '.l10n('no').'</td>
					</tr>
					<tr>
						<td><b>'.l10n('renameORNOT').' :</b></td>
						<td><input type="radio" name="renameORNOT" value="true" '.(($renameORNOT)?'checked':'').'/> '.l10n('yes').' <input type="radio" name="renameORNOT" value="false" '.((!$renameORNOT)?'checked':'').'/> '.l10n('no').'</td>
					</tr>
					<tr>
						<td><b>'.l10n('indexORNOT').' :</b></td>
						<td><input type="radio" name="indexORNOT" value="true" '.(($indexORNOT)?'checked':'').'/> '.l10n('yes').' <input type="radio" name="indexORNOT" value="false" '.((!$indexORNOT)?'checked':'').'/> '.l10n('no').'</td>
					</tr>
					<tr>
						<td><b>'.l10n('prefixe_mini').' :</b></td>
						<td><input type="text" name="prefixe_mini" value="'.$prefixe_mini.'" size="8"/></td>
					</tr>
				</table>
			</li>
			<li>
				<span class="title">'.l10n('Sizes and quality').'</span>
				<table>
					<tr>
						<td><b>'.l10n('DIMhd').' :</b></td>
						<td><input type="text" name="DIMhd" value="'.$DIMhd.'" size="4"/></td>
					</tr>
					<tr>
						<td><b>'.l10n('DIMnormal').' :</b></td>
						<td><input type="text" name="DIMnormal" value="'.$DIMnormal.'" size="3"/></td>
					</tr>
					<tr>
						<td><b>'.l10n('DIMthumbnail').' :</b></td>
						<td><input type="text" name="DIMthumbnail" value="'.$DIMthumbnail.'" size="3"/></td>
					</tr>
					<tr>
						<td><b>'.l10n('Qhd').' :</b></td>
						<td><input type="text" name="Qhd" value="'.$Qhd.'" size="3"/></td>
					</tr>
					<tr>
						<td><b>'.l10n('Qnormal').' :</b></td>
						<td><input type="text" name="Qnormal" value="'.$Qnormal.'" size="3"/></td>
					</tr>
					<tr>
						<td><b>'.l10n('Qthumbnail').' :</b></td>
						<td><input type="text" name="Qthumbnail" value="'.$Qthumbnail.'" size="3"/></td>
					</tr>
					<tr>
						<td><b>'.l10n('DPI').' :</b></td>
						<td><input type="text" name="DPI" value="'.$DPI.'" size="3"/></td>
					</tr>
				</table>
			</li>
			<li>
				<span class="title">'.l10n('Copyright').'</span>
				<table>
					<tr>
						<td><b>'.l10n('Content').' :</b></td>
						<td><input type="text" name="copyright" value="'.$copyright.'"/></td>
					</tr>
					<tr>
						<td><b>'.l10n('copyONhd').' :</b></td>
						<td><input type="radio" name="copyONhd" value="true" '.(($copyONhd)?'checked':'').'/> '.l10n('yes').' <input type="radio" name="copyONhd" value="false" '.((!$copyONhd)?'checked':'').'/> '.l10n('no').'</td>
					</tr>
					<tr>
						<td><b>'.l10n('copyONnormal').' :</b></td>
						<td><input type="radio" name="copyONnormal" value="true" '.(($copyONnormal)?'checked':'').'/> '.l10n('yes').' <input type="radio" name="copyONnormal" value="false" '.((!$copyONnormal)?'checked':'').'/> '.l10n('no').'</td>
					</tr>
					<tr>
						<td><b>'.l10n('copyPOS%s', l10n('copyPOSv')).' :</b></td>
						<td><input type="radio" name="copyPOS[0]" value="top" '.(($copyPOS[0]=='top')?'checked':'').'/> '.l10n('top').' <input type="radio" name="copyPOS[0]" value="center" '.(($copyPOS[0]=='center')?'checked':'').'/> '.l10n('center').' <input type="radio" name="copyPOS[0]" value="bottom" '.(($copyPOS[0]=='bottom')?'checked':'').'/> '.l10n('bottom').'</td>
					</tr>
					<tr>
						<td><b>'.l10n('copyPOS%s', l10n('copyPOSh')).' :</b></td>
						<td><input type="radio" name="copyPOS[1]" value="left" '.(($copyPOS[1]=='left')?'checked':'').'/> '.l10n('left').' <input type="radio" name="copyPOS[1]" value="center" '.(($copyPOS[1]=='center')?'checked':'').'/> '.l10n('center').' <input type="radio" name="copyPOS[1]" value="right" '.(($copyPOS[1]=='right')?'checked':'').'/> '.l10n('right').'</td>
					</tr>
					<tr>
						<td><b>'.l10n('copySIZE').' :</b></td>
						<td><input type="text" name="copySIZE" value="'.$copySIZE.'" size="5"/></td>
					</tr>
					<tr>
						<td><b>'.l10n('copyCOLOR').' :</b></td>
						<td>
							<input type="text" name="copyCOLOR[0]" value="'.$copyCOLOR[0].'" size="3" onFocus="this.select();" onKeyUp="suivant(this,\'copyCOLOR[1]\', 3)"/>
							<input type="text" name="copyCOLOR[1]" value="'.$copyCOLOR[1].'" size="3" onFocus="this.select();" onKeyUp="suivant(this,\'copyCOLOR[2]\', 3)"/>
							<input type="text" name="copyCOLOR[2]" value="'.$copyCOLOR[2].'" size="3" onFocus="this.select();" />
						</td>
					</tr>
					<tr>
						<td><b>'.l10n('copyFONT').' :</b></td>
						<td><input type="text" name="copyFONT" value="'.$copyFONT.'"/></td>
					</tr>
				</table>
			</li>
		</ul>
	</div>

	<div class="config">
		<h2>'.l10n('Plugins').'</h2>
		<ul>
			<li>
				<span class="title">'.l10n('PluginsBefore').'</span>
				<ul>';
					foreach ($PluginsBefore as $name => $config) {
						echo '<li>
							<b class="'.((isset($NewPlugins[$name]))?'new':'').'">'.$name.' :</b>
							<table>';
								foreach ($config as $key => $value) {
									echo '<tr>
										<td>'.$key.' :</td>
										<td><input type="text" name="PluginsBefore['.$name.']['.$key.']" value="'.bool_to_string($value,1).'" size="7"/></td>
									</tr>';
								}
							echo '</table>
						</li>';
					}
				echo '</ul>
			</li>
			<li>
				<span class="title">'.l10n('PluginsProcess').'</span>
				<ul>';
					foreach ($PluginsProcess as $name => $config) {
						echo '<li>
							<b class="'.((isset($NewPlugins[$name]))?'new':'').'">'.$name.' :</b>
							<table>';
								foreach ($config as $key => $value) {
									echo '<tr>
										<td>'.$key.' :</td>
										<td><input type="text" name="PluginsProcess['.$name.']['.$key.']" value="'.bool_to_string($value,1).'" size="7"/></td>
									</tr>';
								}
							echo '</table>
						</li>';
					}
				echo '</ul>
			</li>
			<li>
				<span class="title">'.l10n('PluginsAfter').'</span>
				<ul>';
					foreach ($PluginsAfter as $name => $config) {
						echo '<li>
							<b class="'.((isset($NewPlugins[$name]))?'new':'').'">'.$name.' :</b>
							<table>';
								foreach ($config as $key => $value) {
									echo '<tr>
										<td>'.$key.' :</td>
										<td><input type="text" name="PluginsAfter['.$name.']['.$key.']" value="'.bool_to_string($value,1).'" size="7"/></td>
									</tr>';
								}
							echo '</table>
						</li>';
					}
				echo '</ul>
			</li>
		</ul>
	</div>

	<div class="finish">	
		<input type="submit"/> <input type="reset"/> <a href="index.php">'.l10n('Back').'</a>
	</div>
	</form>';
}

echo '</body>
</html>';
?>